diff -uNrd ircd-hybrid-6.2/src/s_user.c ircd-hyb6.2-FEFr5/src/s_user.c
--- ircd-hybrid-6.2/src/s_user.c	Tue Jul 17 21:37:18 2001
+++ ircd-hyb6.2-FEFr5/src/s_user.c	Tue Aug 21 01:55:29 2001
@@ -498,6 +498,91 @@
 
 
 /*
+ *  check_clones
+ *    This function counts the number of clients with the
+ *    same host as cptr that connected less than CHECK_CLONE_PERIOD
+ *    seconds ago.
+ *  return value
+ *    -1: reject connections
+ *     0: permit connections
+ *  -SeKs -record
+ */
+#ifdef CHECK_CLONE
+static int check_clones(aClient * cptr)
+{
+  struct abacklog
+  {
+    time_t last;
+    char host[HOSTLEN];
+    int count;
+    struct abacklog *next;
+  };
+
+  static struct abacklog *backlog = NULL;
+  register struct abacklog **blscn = &backlog, *blptr;
+
+  /* Find the host we're interested in. While we're at it, we'll
+   * clean out expired elements from the list.                    */
+
+  while ((*blscn != NULL) && (strcmp(cptr->host, (*blscn)->host)))
+  {
+    if ((*blscn)->last + CHECK_CLONE_PERIOD < CurrentTime)
+    {                           /* expired; remove */
+      if ((*blscn)->count == -1)
+        sendto_ops("Removing throttle for %s.", (*blscn)->host);
+      blptr = *blscn;
+      *blscn = blptr->next;
+      MyFree((char *)blptr);
+    }
+    else
+      blscn = &(*blscn)->next;
+  }
+
+  if (*blscn)                   /* There is a record for this host */
+  {
+    if (!((*blscn)->last + CHECK_CLONE_PERIOD < CurrentTime))   /* not expired */
+    {
+      (*blscn)->last = CurrentTime;
+      if ((*blscn)->count == -1)
+        return (-1);
+      else
+      {
+        (*blscn)->count++;
+        if (((*blscn)->count == CHECK_CLONE_LIMIT) && !IsFlined(cptr))
+        {
+          sendto_ops("Throttling connections from %s.", (*blscn)->host);
+          (*blscn)->count = -1;
+          return (-1);
+        }
+        else
+          return (0);
+      }
+    }
+    else
+      /* expired */
+    {
+      if ((*blscn)->count == -1)
+        sendto_ops("Removing throttle for %s.", (*blscn)->host);
+      (*blscn)->last = CurrentTime;
+      (*blscn)->count = 1;
+      return (0);
+    }
+  }
+  else
+    /* no record for host; make one */
+  {
+    blptr = (struct abacklog *)MyMalloc(sizeof(struct abacklog));
+    strncpy_irc(blptr->host, cptr->host, HOSTLEN);
+    blptr->next = backlog;
+    blptr->last = CurrentTime;
+    blptr->count = 1;
+    backlog = blptr;
+    return (0);
+  }
+}
+#endif
+
+/*
 ** register_user
 **      This function is called when both NICK and USER messages
 **      have been accepted for the client, in whatever order. Only
@@ -521,7 +606,7 @@
 **         nick from local user or kill him/her...
 */
 
-static int register_user(aClient *cptr, aClient *sptr, 
+int register_user(aClient *cptr, aClient *sptr,
                          char *nick, char *username)
 {
   aConfItem*  aconf;
@@ -589,19 +674,19 @@
 	/* jdc - lists server name & port connections are on */
 	/*       a purely cosmetical change */
               sendto_realops_flags(FLAGS_CCONN,
-				 "%s from %s [%s] on [%s/%u].",
+                                 "%s from %s [%s] on [%s/%u].",
                                  "Unauthorized client connection",
                                  get_client_host(sptr),
                                  inetntoa((char *)&sptr->ip),
-				 sptr->listener->name,
-				 sptr->listener->port
-				 );
+                                 sptr->listener->name,
+                                 sptr->listener->port
+                                 );
               log(L_INFO,
-		  "Unauthorized client connection from %s on [%s/%u].",
+                  "Unauthorized client connection from %s on [%s/%u].",
                   get_client_host(sptr),
-		  sptr->listener->name,
-		  sptr->listener->port
-		  );
+                  sptr->listener->name,
+                  sptr->listener->port
+                  );
 
               ServerStats->is_ref++;
               return exit_client(cptr, sptr, &me,
@@ -643,7 +728,7 @@
           sendto_one(sptr,":%s NOTICE %s :*** Notice -- You have an illegal character in your hostname", 
                      me.name, sptr->name );
 
-          strncpy(sptr->host,sptr->sockhost,HOSTIPLEN+1);
+          strncpy_irc(sptr->host,sptr->sockhost,HOSTIPLEN+1);
         }
 
       aconf = sptr->confs->value.aconf;
@@ -667,6 +752,9 @@
              {
                 *sptr->username = '~';
                 strncpy_irc(&sptr->username[1], username, USERLEN - 1);
+		sendto_one(sptr,
+":%s NOTICE %s :*** Notice -- You need to install identd if you wish to have your username show up without the ~ (tilde)",
+			   me.name, cptr->name);
              }
            sptr->username[USERLEN] = '\0';
         }
@@ -742,6 +830,25 @@
         }
       /* end of valid user name check */
 
+#ifdef CHECK_CLONE
+
+	/*
+	 * Add this local client into the clone check database.  If the
+	 * site has been throttled, reject the user. -SeKs -record
+	 */
+
+	if (check_clones(sptr) == -1
+#ifdef CHECK_CLONE_DELAY
+	    && me.since + CHECK_CLONE_DELAY < CurrentTime
+#endif
+	    )
+	{
+	  ServerStats->is_ref++;
+	  return exit_client(cptr, sptr, &me,
+	    "Too many connections from your host -- throttled");
+	}
+#endif
+
       if(!IsAnOper(sptr))
         {
           char *xreason;
@@ -812,7 +919,7 @@
 
   if (MyConnect(sptr))
     {
-      sendto_one(sptr, form_str(RPL_WELCOME), me.name, nick, nick);
+      sendto_one(sptr, form_str(RPL_WELCOME), me.name, nick, NETWORK_NAME, nick);
       /* This is a duplicate of the NOTICE but see below...*/
       sendto_one(sptr, form_str(RPL_YOURHOST), me.name, nick,
                  get_listener_name(sptr->listener), version);
@@ -922,6 +1029,11 @@
       ubuf[1] = '\0';
     }
   
+#ifdef CHECK_CLONE
+	if (!IsSLine(sptr))
+		check_clones(sptr);
+#endif
+
   /* LINKLIST 
    * add to local client link list -Dianora
    * I really want to move this add to link list
@@ -1158,6 +1270,7 @@
 static int nickkilldone(aClient *cptr, aClient *sptr, int parc,
                  char *parv[], time_t newts,char *nick)
 {
+	Link	*lp;
 
   if (IsServer(sptr))
     {
@@ -1207,6 +1320,23 @@
     }
   else if (sptr->name[0])
     {
+		/*
+		** If the client belongs to me, then check to see
+		** if client is currently on any channels where it
+		** is currently banned.  If so, do not allow the nick
+		** change to occur.
+		*/
+		if (MyClient(sptr))
+			for (lp = cptr->user->channel; lp; lp = lp->next)
+				if ((can_send(cptr, lp->value.chptr) ==
+				    MODE_BAN) && !IsSLine(sptr)) {
+					sendto_one(cptr,
+						   form_str(ERR_BANNICKCHANGE),
+						   me.name, parv[0],
+						   lp->value.chptr->chname);
+					return 0;
+				}
+
       /*
       ** Client just changing his/her nick. If he/she is
       ** on a channel, send note of change to all clients
@@ -1255,7 +1385,12 @@
         {
           sendto_common_channels(sptr, ":%s NICK :%s", parv[0], nick);
           if (sptr->user)
-            {
+#ifdef ANTI_IP_SPOOF
+	/* Don't send out a nick-change if they haven't PONG'd us
+	 * because they haven't registered yet if they haven't! -JailBird */
+	if ((!MyConnect(sptr)) || (sptr->flags2 & FLAGS2_GOT_ANTI_SPOOF_PING)) 
+#endif
+           {
               add_history(sptr,1);
               sendto_serv_butone(cptr, ":%s NICK %s :%lu",
                                  parv[0], nick, sptr->tsinfo);
@@ -1283,6 +1418,19 @@
           ** may reject the client and call exit_client for it
           ** --must test this and exit m_nick too!!!
           */
+/* anti ip sequence prediction spoof code
+   it needs a good going over by someone else, but it
+   works... -Dianora
+*/
+#ifdef ANTI_IP_SPOOF
+	if(MyConnect(sptr))
+	{
+		strcpy(sptr->name,nick);
+		sptr->random_ping = (unsigned int)my_rand();
+		sendto_one(sptr, "PING :%d", sptr->random_ping);
+		sptr->flags |= FLAGS_PINGSENT;
+	} else
+#endif
             if (register_user(cptr, sptr, nick, buf) == CLIENT_EXITED)
               return CLIENT_EXITED;
         }
@@ -1972,6 +2120,21 @@
     }
   strncpy_irc(sptr->info, realname, REALLEN);
 
+#ifdef ANTI_IP_SPOOF
+  user->last = CurrentTime;
+  if(MyConnect(sptr))
+     {
+       if (sptr->name[0]) /* NICK already received, now I have USER... */
+         {
+	   sptr->random_ping = (unsigned int)my_rand();
+	   sendto_one(sptr, "PING :%d", sptr->random_ping);
+	   sptr->flags |= FLAGS_PINGSENT;  
+	 }
+       if (!IsGotId(sptr))
+         strncpy_irc(sptr->username, username, USERLEN);
+       return 0;
+     } 
+#endif
   if (sptr->name[0]) /* NICK already received, now I have USER... */
     return register_user(cptr, sptr, sptr->name, username);
   else
@@ -2022,7 +2185,7 @@
       return 0;
     }
 
-  if (IsServer(sptr) || sptr != acptr || acptr->from != sptr->from)
+  if ((IsServer(sptr) && !IsSLine(sptr)) || sptr != acptr || acptr->from != sptr->from)
     {
       if (IsServer(cptr))
         sendto_ops_butone(NULL, &me,
@@ -2280,4 +2443,118 @@
   return 0;
 }
 #endif
+
+
+/*
+** m_snick
+**      parv[0] = sender prefix
+**      parv[1] = original nickname
+**      parv[2] = new nickname
+**	parv[3] = TS
+/* This function is a shameless merger between m_nick and
+   DalNet's m_svsnick().  I have tried to cover any issue
+   that could come up.  -JailBird */
+int m_snick(aClient *cptr, aClient *sptr, int parc, char *parv[])
+{
+  aClient* acptr;
+  char     nick[NICKLEN + 2];
+  char     *s;
+  time_t   newts = 0;
+
+  /* Check to make sure this is comming from a service */
+  if (!IsSLine(sptr))
+      return 0;
+
+  /* Since this is from a service, just return, don't send an error */
+  if (parc < 4)
+      return 0;
+
+  if (s = strchr(parv[2], '~'))
+    *s = '\0';
+
+  /* Terminate the string */
+  strncpy_irc(nick, parv[2], NICKLEN);
+  nick[NICKLEN] = '\0';
+
+  acptr = find_client(parv[1], NULL);
+  /* If the nick was bad, then just KILL the client */
+  if (clean_nick_name(nick) == 0 || strcmp(nick, parv[2])) {
+    ServerStats->is_kill++;
+    sendto_realops_flags(FLAGS_DEBUG, "Bad Nick: %s From SNICK: %s",
+                         nick, parv[1]);
+    sendto_serv_butone(cptr, ":%s KILL %s :%s SNICK to %s",
+                       me.name, parv[1], me.name, nick);
+    sendto_one(cptr, ":%s KILL %s :%s SNICK from %s",
+               me.name, nick, me.name, parv[1]);
+    sptr->flags |= FLAGS_KILLED;
+    if (acptr != NULL)
+      return exit_client(NULL, acptr, &me, "Bad Nick");
+  }
+
+  /* Is the nickname identical to a server's name? */
+  if (find_server(nick) != NULL) {
+    sendto_ops("SNICK Nick collision for %s <- %s",
+               nick, parv[1]);
+    ServerStats->is_kill++;
+    sendto_one(cptr, ":%s KILL %s :%s (%s <- %s)",
+               me.name, parv[1], me.name, nick, parv[1]);
+    sptr->flags |= FLAGS_KILLED;
+    if (acptr != NULL)
+      return exit_client(NULL, acptr, &me, "Nick/Server Collision");
+  }
+ 
+  /* Do we have a collision situation? */
+  if (find_client(nick, NULL) != NULL) {
+    sendto_ops("SNICK Nick change collision for %s <- %s",
+		nick, parv[1]);
+    sendto_serv_butone(cptr, ":%s KILL %s :%s (%s <- %s)",
+                       me.name, parv[1], me.name, nick, parv[1]);
+    sendto_one(cptr, ":%s KILL %s :%s (%s <- %s)",
+               me.name, nick, me.name, nick, parv[1]);
+    sptr->flags |= FLAGS_KILLED;
+    if (acptr != NULL)
+      return exit_client(NULL,acptr,&me,"Bad Nick");
+  }
+
+  if (hunt_server(cptr, sptr, ":%s SNICK %s %s :%s", 1, parc, parv)
+      ==HUNTED_ISME) {
+    if ((acptr = find_person(parv[1], NULL))) {
+      newts = atol(parv[3]);
+      acptr->tsinfo = newts;
+      sendto_realops_flags(FLAGS_NCHANGE,
+                           "Nick change: From %s to %s [%s@%s]",
+                           parv[1], nick, acptr->username, acptr->host);
+      sendto_common_channels(acptr, ":%s NICK :%s", parv[1], nick);
+      if (acptr->user) {
+        add_history(acptr, 1);
+        sendto_serv_butone(NULL, ":%s NICK %s :%lu", parv[1],
+                           nick, acptr->tsinfo);
+      }
+      if (sptr->name[0])
+        del_from_client_hash_table(acptr->name, acptr);
+      strcpy(acptr->name, nick);
+      add_to_client_hash_table(nick, acptr);
+    }
+  }
+  return 0;
+}
+
+/* check to see if the message has any color chars in it. */
+int msg_has_colors(char *msg)
+{
+   char *c = msg;
+
+   while(*c)
+   {
+      if(*c == '\003' || *c == '\033')
+         break;
+      else
+         c++;
+   }
+
+   if(*c)
+      return 1;
+
+   return 0;
+}
 
diff -uNrd ircd-hybrid-6.2/src/send.c ircd-hyb6.2-FEFr5/src/send.c
--- ircd-hybrid-6.2/src/send.c	Tue Jul 10 08:40:37 2001
+++ ircd-hyb6.2-FEFr5/src/send.c	Tue Aug 21 01:52:24 2001
@@ -44,7 +44,7 @@
 #include <time.h>
 #include <assert.h>
 
-#define NEWLINE "\r\n"
+#define NEWLINE "\n"
 #define LOG_BUFSIZE 2048
 
 static  char    sendbuf[2048];
@@ -487,16 +487,18 @@
    * of an overflow.
    * -wnder
    */
+   /* Always #define IRCII_KLUDGE and break the RFC by only sending
+    * \n and NOT \r\n. This allows DCC RAW connections to work.
+    * -JailBird
+    */
         if (len > 510)
         {
-                sendbuf[510] = '\r';
-                sendbuf[511] = '\n';
-                sendbuf[512] = '\0';
-                len = 512;
+                sendbuf[510] = '\n';
+                sendbuf[511] = '\0';
+                len = 511;
         }
         else
         {
-                sendbuf[len++] = '\r';
                 sendbuf[len++] = '\n';
                 sendbuf[len] = '\0';
         }
@@ -507,7 +509,7 @@
 } /* vsendto_one() */
 
 void
-sendto_channel_butone(aClient *one, aClient *from, aChannel *chptr, 
+sendto_channel_butone(aClient *one, aClient *from, aChannel *chptr,
                       const char *pattern, ...)
 
 {
@@ -552,7 +554,7 @@
 } /* sendto_channel_butone() */
 
 void
-sendto_channel_type(aClient *one, aClient *from, aChannel *chptr,
+sendto_channel_type(aClient *one, aClient *from, aChannel *chptr, 
                     int type,
                     const char *nick,
                     const char *cmd,
@@ -607,8 +609,8 @@
                */
               if (sentalong[i] != current_serial)
                 {
-                  sendto_prefix_one(acptr, from,
-                    ":%s NOTICE %s :%s",
+                    sendto_prefix_one(acptr, from,
+                      ":%s NOTICE %s :%s",
                     from->name,
                     lp->value.cptr->name, /* target name */
                     message);
@@ -1310,16 +1312,16 @@
   len = parlen;
   len += vsprintf_irc(outbuf + parlen, &pattern[4], args);
 
+/* Violate the RFC by not sending a CR (\r). No client requires the CR,
+   and it causes havoc with ircII-based DCC RAW scripts. -JailBird */
   if (len > 510)
   {
-    outbuf[510] = '\r';
-    outbuf[511] = '\n';
-    outbuf[512] = '\0';
-    len = 512;
+    outbuf[510] = '\n';
+    outbuf[511] = '\0';
+    len = 511;
   }
   else
   {
-    outbuf[len++] = '\r';
     outbuf[len++] = '\n';
     outbuf[len] = '\0';
   }
diff -uNrd ircd-hybrid-6.2/src/version.c.SH ircd-hyb6.2-FEFr5/src/version.c.SH
--- ircd-hybrid-6.2/src/version.c.SH	Mon Jun  4 11:23:39 2001
+++ ircd-hyb6.2-FEFr5/src/version.c.SH	Tue Aug 21 02:04:58 2001
@@ -79,6 +79,19 @@
 done
 $spitshell >>version.c <<!SUB!THISTOO!
   "",
+  "The FEFnet ircd coding team consists of the following people:",
+  "",
+  "JailBird            Dustin Marquess     jailbird@alcatraz.fdf.net",
+  "Runt                John Leslie         john@stf.org",
+  "",
+  "The following people helped contribute code to the FEFnet ircd project",
+  "by supplying code, ideas, etc:",
+  "",
+  "Raistlin     SPaM     inubus     Ryan     Viv",
+  "",
+  "The FEFnet ircd was developed on the Linux operating system using",
+  "glibc2.1.3 and using the egcs-1.1.2 C compiler.",
+  "",
   0,
 };
 !SUB!THISTOO!
